// ============================================================ //
#ifndef _SQ7615_IAP_CFG_H__
#define _SQ7615_IAP_CFG_H__
// ============================================================ //


/* -------------------------------------------------------------*/
// IAP_Boot
void iap_boot( void);
/* -------------------------------------------------------------*/



/* -------------------------------------------------------------*/
// Normal boot start address:
// 趨ʼλ
//
#define NORMAL_BOOT_ADDRESS		(0x0800)
/* -------------------------------------------------------------*/
// ˵:
//      IAP LibraryϴСԼʹ2048Bytes(0x0800(hex))ĴС,
//      ʹ߱ʼλ趨λַʼ,С춴λַ
//      LCF(Sample Link Command File)Ѿ趨ͬλַ
/* -------------------------------------------------------------*/



/* -------------------------------------------------------------*/
// Baud rate select:
// ̬ѡһΪ IAP UART Baudrate Speedʹ
// -- Baud Rate Setting------
// 
#define Operat24MBaud_115200   
//#define Operat24MBaud_57600    
//#define Operat24MBaud_19200    
//#define Operat24MBaud_9600
/* -------------------------------------------------------------*/



/*--------------------------------------------------------------*/
// UART interface select:
// ̬ѡһΪ IAP UART ݔʹ
//
//#define IAP_CONFIG_UART0_TxP01_RxP00		
//#define IAP_CONFIG_UART0_TxP00_RxP01		
//#define IAP_CONFIG_UART0_TxP37_RxP36		
//#define IAP_CONFIG_UART0_TxP36_RxP37		
//#define IAP_CONFIG_UART1_TxP26_RxP25		
//#define IAP_CONFIG_UART1_TxP25_RxP26		
#define IAP_CONFIG_UART1_TxP52_RxP51
//#define IAP_CONFIG_UART1_TxP51_RxP52
//#define IAP_CONFIG_UART2_TxP05_RxP04		
//#define IAP_CONFIG_UART2_TxP04_RxP05		
//#define IAP_CONFIG_UART2_TxP31_RxP30		
//#define IAP_CONFIG_UART2_TxP30_RxP31		
/* -------------------------------------------------------------*/ 
// ˵:
//      IAP_CONFIG_UART0_TxP01_RxP00: ʹUART0, P0.1Ͷ˿,P0.0ն˿
//      IAP_CONFIG_UART0_TxP00_RxP01: ʹUART0, P0.0Ͷ˿,P0.1ն˿
//      IAP_CONFIG_UART0_TxP37_RxP36: ʹUART0, P3.7Ͷ˿,P3.6ն˿
//      IAP_CONFIG_UART0_TxP36_RxP37: ʹUART0, P3.6Ͷ˿,P3.7ն˿
//      IAP_CONFIG_UART1_TxP26_RxP25: ʹUART1, P2.6Ͷ˿,P2.5ն˿
//      IAP_CONFIG_UART1_TxP25_RxP26: ʹUART1, P2.5Ͷ˿,P2.6ն˿
//      IAP_CONFIG_UART1_TxP52_RxP51: ʹUART1, P5.2Ͷ˿,P5.1ն˿
//      IAP_CONFIG_UART1_TxP51_RxP52: ʹUART1, P5.1Ͷ˿,P5.2ն˿
//      IAP_CONFIG_UART2_TxP05_RxP04: ʹUART2, P0.5Ͷ˿,P0.4ն˿
//      IAP_CONFIG_UART2_TxP04_RxP05: ʹUART2, P0.4Ͷ˿,P0.5ն˿
//      IAP_CONFIG_UART2_TxP31_RxP30: ʹUART2, P3.1Ͷ˿,P3.0ն˿
//      IAP_CONFIG_UART2_TxP30_RxP31: ʹUART2, P3.0Ͷ˿,P3.1ն˿
/* -------------------------------------------------------------*/ 



/*--------------------------------------------------------------*/
// UART control setting (parity / stop bit / even)
// 趨 1. (/)żУ
//      2. (/ż)żУ
//      3. Ͷ˽λ
//      4. ն˽λ
//   
#define UART_CR1_VALUE          (0x00)
#define UART_CR2_VALUE          (0x00)
/*--------------------------------------------------------------*/
// :żУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x00
//      UART_CR2_VALUE = 0x00
//
// :żУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x20
//      UART_CR2_VALUE = 0x01
//
// :żУ,żУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x08
//      UART_CR2_VALUE = 0x00
//
// :żУ,żУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x28
//      UART_CR2_VALUE = 0x01
//
// :żУ,żżУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x18
//      UART_CR2_VALUE = 0x00
//
// :żУ,żżУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x38
//      UART_CR2_VALUE = 0x01
/* -------------------------------------------------------------*/



/* -------------------------------------------------------------*/
// Enable Boot PIN Setting: 
// ̬ѡһΪ IAP Boot ʹ
// #define IAP_BOOT_PIN_P01
// #define IAP_BOOT_PIN_P02
// #define IAP_BOOT_PIN_P05
// #define IAP_BOOT_PIN_P10
// #define IAP_BOOT_PIN_P11
// #define IAP_BOOT_PIN_P13
// #define IAP_BOOT_PIN_P14
// #define IAP_BOOT_PIN_P15
// #define IAP_BOOT_PIN_P17
// #define IAP_BOOT_PIN_P20
// #define IAP_BOOT_PIN_P21
// #define IAP_BOOT_PIN_P22
// #define IAP_BOOT_PIN_P24 
// #define IAP_BOOT_PIN_P25
// #define IAP_BOOT_PIN_P26
// #define IAP_BOOT_PIN_P30
// #define IAP_BOOT_PIN_P31
// #define IAP_BOOT_PIN_P32
// #define IAP_BOOT_PIN_P33
// #define IAP_BOOT_PIN_P35
// #define IAP_BOOT_PIN_P43  //Led
 #define IAP_BOOT_PIN_P50
// #define IAP_BOOT_PIN_P51  //Rx
// #define IAP_BOOT_PIN_P52  //Tx
/* -------------------------------------------------------------*/
// ˵:
//     οdatasheetѡʺϿõBoot PIN  
//     ܿ P3.4P4.2(OCD)P4.0P4.1(LX)P4.4P4.5(HX)B                  
//     ɴ PORT_0/PORT_1/PORT_2/PORT_3/PORT_4/PORT_5 δʹýλѡ
/* -------------------------------------------------------------*/
 



/* -------------------------------------------------------------*/
// IAP boot pin default level:
// 趨 IAP Boot ˿(ʼ)λ
// ʼ(Default) ߵλ(High) = 0x01;
//               ͵λ(Low)  = 0x00;
#define IAP_BOOT_GPIO_DEFAULT_HIGH_LOW (0x0000)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// IAP boot pin enable level
// 趨 IAP Boot ˿()λ
// (Enable)  ߵλ(High) = 0x01;
//               ͵λ(Low)  = 0x00;
#define IAP_BOOT_GPIO_ENABLE_HIGH_LOW  (0x001)
/* -------------------------------------------------------------*/







//================= PORT/PIN number define====================================
//============================================================================
#define PORT_0                          (0x00)
#define PORT_1                          (0x01)
#define PORT_2                          (0x02)
#define PORT_3                          (0x03)
#define PORT_4                          (0x04)
#define PORT_5                          (0x05)
#define PORT_6                          (0x06)
#define PORT_7                          (0x07)

#define PIN_0                          (0x00)
#define PIN_1                          (0x01)
#define PIN_2                          (0x02)
#define PIN_3                          (0x03)
#define PIN_4                          (0x04)
#define PIN_5                          (0x05)
#define PIN_6                          (0x06)
#define PIN_7                          (0x07)

//================= PORT REGISTER define  ====================================
//============================================================================
// 
#define P0_FC_REG                      (0x0140)       //P0FC register address
#define P0_FC2_REG                     (0x0150)       //P0FC2 register address
#define P0_PU_REG                      (0x0110)       //P0 Pull-Up register address
#define P0_PD_REG                      (0x0120)       //P0 Pull-Down register address
#define P0_CR_REG                      (0x0100)       //P0 Control register address
#define P0_PRD_REG                     (0x00F0)       //P0 Input Data register address

#define P1_FC_REG                      (0x0141)       //P1FC register address
#define P1_FC2_REG                     (0x0151)       //P1FC2 register address
#define P1_PU_REG                      (0x0111)       //P1 Pull-Up register address
#define P1_PD_REG                      (0x0121)       //P1 Pull-Down register address
#define P1_CR_REG                      (0x0101)       //P1 Control register address
#define P1_PRD_REG                     (0x00F1)       //P1 Input Data register address

#define P2_FC_REG                      (0x0142)       //P2FC register address
#define P2_FC2_REG                     (0x0152)       //P2FC2 register address
#define P2_PU_REG                      (0x0112)       //P2 Pull-Up register address
#define P2_PD_REG                      (0x0122)       //P2 Pull-Down register address
#define P2_CR_REG                      (0x0102)       //P2 Control register address
#define P2_PRD_REG                     (0x00F2)       //P2 Input Data register address

#define P3_FC_REG                      (0x0143)       //P3FC register address
#define P3_FC2_REG                     (0x0153)       //P3FC2 register address
#define P3_PU_REG                      (0x0113)       //P3 Pull-Up register address
#define P3_PD_REG                      (0x0123)       //P3 Pull-Down register address
#define P3_CR_REG                      (0x0103)       //P3 Control register address
#define P3_PRD_REG                     (0x00F3)       //P3 Input Data register address

#define P4_FC_REG                      (0x0144)       //P4FC register address
#define P4_FC2_REG                     (0x0154)       //P4FC2 register address
#define P4_PU_REG                      (0x0114)       //P4 Pull-Up register address
#define P4_PD_REG                      (0x0124)       //P4 Pull-Down register address
#define P4_CR_REG                      (0x0104)       //P4 Control register address
#define P4_PRD_REG                     (0x00F4)       //P4 Input Data register address

#define P5_FC_REG                      (0x0145)       //P5FC register address
#define P5_FC2_REG                     (0x0155)       //P5FC2 register address
#define P5_PU_REG                      (0x0115)       //P5 Pull-Up register address
#define P5_PD_REG                      (0x0125)       //P5 Pull-Down register address
#define P5_CR_REG                      (0x0105)       //P5 Control register address
#define P5_PRD_REG                     (0x00F5)       //P5 Input Data register address


//================= Boot_Pin Selection define  ===================================
//============================================================================
#ifdef IAP_BOOT_PIN_P00
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_0)	
#endif

#ifdef IAP_BOOT_PIN_P01
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_1)	
#endif

#ifdef IAP_BOOT_PIN_P02
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_2)	
#endif

#ifdef IAP_BOOT_PIN_P04
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_4)	
#endif

#ifdef IAP_BOOT_PIN_P05
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_5)	
#endif

#ifdef IAP_BOOT_PIN_P06
#define IAP_BOOT_PORT_SELECT	(PORT_0)
#define IAP_BOOT_PIN_SELECT		(PIN_6)	
#endif

#ifdef IAP_BOOT_PIN_P10
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_0)	
#endif

#ifdef IAP_BOOT_PIN_P11
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_1)	
#endif

#ifdef IAP_BOOT_PIN_P12
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_2)	
#endif

#ifdef IAP_BOOT_PIN_P13
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_3)	
#endif

#ifdef IAP_BOOT_PIN_P14
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_4)	
#endif

#ifdef IAP_BOOT_PIN_P15
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_5)	
#endif

#ifdef IAP_BOOT_PIN_P16
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_6)	
#endif

#ifdef IAP_BOOT_PIN_P17
#define IAP_BOOT_PORT_SELECT	(PORT_1)
#define IAP_BOOT_PIN_SELECT		(PIN_7)	
#endif

#ifdef IAP_BOOT_PIN_P20
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_0)	
#endif

#ifdef IAP_BOOT_PIN_P21
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_1)	
#endif

#ifdef IAP_BOOT_PIN_P22
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_2)	
#endif

#ifdef IAP_BOOT_PIN_P24
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_4)	
#endif

#ifdef IAP_BOOT_PIN_P25
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_5)	
#endif

#ifdef IAP_BOOT_PIN_P26
#define IAP_BOOT_PORT_SELECT	(PORT_2)
#define IAP_BOOT_PIN_SELECT		(PIN_6)	
#endif

#ifdef IAP_BOOT_PIN_P30
#define IAP_BOOT_PORT_SELECT	(PORT_3)
#define IAP_BOOT_PIN_SELECT		(PIN_0)	
#endif

#ifdef IAP_BOOT_PIN_P31
#define IAP_BOOT_PORT_SELECT	(PORT_3)
#define IAP_BOOT_PIN_SELECT		(PIN_1)	
#endif

#ifdef IAP_BOOT_PIN_P32
#define IAP_BOOT_PORT_SELECT	(PORT_3)
#define IAP_BOOT_PIN_SELECT		(PIN_2)	
#endif

#ifdef IAP_BOOT_PIN_P33
#define IAP_BOOT_PORT_SELECT	(PORT_3)
#define IAP_BOOT_PIN_SELECT		(PIN_3)	
#endif

#ifdef IAP_BOOT_PIN_P35
#define IAP_BOOT_PORT_SELECT	(PORT_3)
#define IAP_BOOT_PIN_SELECT		(PIN_5)	
#endif

#ifdef IAP_BOOT_PIN_P43
#define IAP_BOOT_PORT_SELECT	(PORT_4)
#define IAP_BOOT_PIN_SELECT		(PIN_3)	
#endif

#ifdef IAP_BOOT_PIN_P50
#define IAP_BOOT_PORT_SELECT	(PORT_5)
#define IAP_BOOT_PIN_SELECT		(PIN_0)	
#endif

#ifdef IAP_BOOT_PIN_P51
#define IAP_BOOT_PORT_SELECT	(PORT_5)
#define IAP_BOOT_PIN_SELECT		(PIN_1)	
#endif

#ifdef IAP_BOOT_PIN_P52
#define IAP_BOOT_PORT_SELECT	(PORT_5)
#define IAP_BOOT_PIN_SELECT		(PIN_2)	
#endif



//================= PORT Selection define  ===================================
//============================================================================
// 
#if (IAP_BOOT_PORT_SELECT == PORT_0)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P0_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P0_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P0_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P0_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P0_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P0_PRD_REG)
#endif

#if (IAP_BOOT_PORT_SELECT == PORT_1)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P1_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P1_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P1_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P1_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P1_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P1_PRD_REG)
#endif

#if (IAP_BOOT_PORT_SELECT == PORT_2)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P2_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P2_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P2_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P2_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P2_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P2_PRD_REG)
#endif

#if (IAP_BOOT_PORT_SELECT == PORT_3)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P3_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P3_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P3_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P3_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P3_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P3_PRD_REG)
#endif

#if (IAP_BOOT_PORT_SELECT == PORT_4)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P4_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P4_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P4_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P4_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P4_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P4_PRD_REG)
#endif

#if (IAP_BOOT_PORT_SELECT == PORT_5)
#define IAP_BOOT_PIN_FUNCTION_ADR     (P5_FC_REG)
#define IAP_BOOT_PIN_FUNCTION2_ADR    (P5_FC2_REG)
#define IAP_BOOT_PIN_PULL_UP_ADR      (P5_PU_REG)
#define IAP_BOOT_PIN_PULL_DOWN_ADR    (P5_PD_REG)
#define IAP_BOOT_PIN_CONTROL_ADR      (P5_CR_REG)
#define IAP_BOOT_PIN_INPUT_ADR        (P5_PRD_REG)
#endif



//================= UART configure define  ===================================
//============================================================================
// 
#ifdef Operat24MBaud_115200
#define BaudrateSetting	( DR = 0x0C, RT = 0x00 )	
#endif

#ifdef Operat24MBaud_57600
#define BaudrateSetting	( DR = 0x19, RT = 0x00 )	
#endif

#ifdef Operat24MBaud_19200
#define BaudrateSetting	( DR = 0x4D, RT = 0x00 )	
#endif

#ifdef Operat24MBaud_9600
#define BaudrateSetting	( DR = 0x92, RT = 0x04 )	
#endif




//=====================================================
// -- UART0 Tx: P01 Rx: P00   -->
#ifdef		IAP_CONFIG_UART0_TxP01_RxP00		
#define IAP_UART_CR_ADR         (0x0100)		//P0OE
#define IAP_UART_TX_PIN         (0x01)
#define IAP_UART_RX_PIN			(0x00)
#define IAP_UART_FC_ADR         (0x0140)		//P0FC1
#define IAP_UART_FC2_ADR        (0x0150)		//P0FC2

#define IAP_UART_TDBUF_ADR      (0x00A5)       // UART0 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00A4)       // UART0 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A3)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x00A2)
#define IAP_UART_CR1_ADR        (0x00A0)
#define IAP_UART_CR2_ADR        (0x00A1)

#define IAP_UART_No				0			
#define IAP_PxPU_ADR			(0x0110)
#define IAP_Uart_PinSelect		P0FC1_P1=1; P0FC1_P0=1; P0FC2_P1=0; P0FC2_P0=0;	PCSELR0_UART0=0; FSELR0=(FSELR0&0xF0)|(0<<0); 					
#endif

// -- UART0 Tx: P00 Rx: P01   -->
#ifdef		IAP_CONFIG_UART0_TxP00_RxP01		
#define IAP_UART_CR_ADR         (0x0100)		//P0OE
#define IAP_UART_TX_PIN         (0x00)
#define IAP_UART_RX_PIN			(0x01)
#define IAP_UART_FC_ADR         (0x0140)		//P0FC1
#define IAP_UART_FC2_ADR        (0x0150)		//P0FC2

#define IAP_UART_TDBUF_ADR      (0x00A5)       // UART0 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00A4)       // UART0 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A3)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x00A2)
#define IAP_UART_CR1_ADR        (0x00A0)
#define IAP_UART_CR2_ADR        (0x00A1)

#define IAP_UART_No				0			
#define IAP_PxPU_ADR			(0x0110)
#define IAP_Uart_PinSelect		P0FC1_P1=1; P0FC1_P0=1; P0FC2_P1=0; P0FC2_P0=0;	PCSELR0_UART0=0; FSELR0=(FSELR0&0xF0)|(1<<0); 					
#endif

// -- UART0 Tx: P37 Rx: P36   -->
#ifdef		IAP_CONFIG_UART0_TxP37_RxP36		
#define IAP_UART_CR_ADR         (0x0103)		//P3OE
#define IAP_UART_TX_PIN         (0x07)
#define IAP_UART_RX_PIN			(0x06)
#define IAP_UART_FC_ADR         (0x0143)		//P3FC1
#define IAP_UART_FC2_ADR        (0x0153)		//P3FC2

#define IAP_UART_TDBUF_ADR      (0x00A5)       // UART0 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00A4)       // UART0 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A3)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x00A2)
#define IAP_UART_CR1_ADR        (0x00A0)
#define IAP_UART_CR2_ADR        (0x00A1)

#define IAP_UART_No				0			
#define IAP_PxPU_ADR			(0x0113)		//P3PU
#define IAP_Uart_PinSelect		P3FC1_P7=1;  P3FC1_P6=1; P3FC2_P7=0; P3FC2_P6=0; PCSELR0_UART0=1; FSELR3=(FSELR0&0x0F)|(0<<4); 					
#endif

// -- UART0 Tx: P36 Rx: P37   -->
#ifdef		IAP_CONFIG_UART0_TxP36_RxP37		
#define IAP_UART_CR_ADR         (0x0103)		//P3OE
#define IAP_UART_TX_PIN         (0x06)
#define IAP_UART_RX_PIN			(0x07)
#define IAP_UART_FC_ADR         (0x0143)		//P3FC1
#define IAP_UART_FC2_ADR        (0x0153)		//P3FC2

#define IAP_UART_TDBUF_ADR      (0x00A5)       // UART0 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00A4)       // UART0 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A3)       // UART0 Status register address
#define IAP_UART_DR_ADR         (0x00A2)
#define IAP_UART_CR1_ADR        (0x00A0)
#define IAP_UART_CR2_ADR        (0x00A1)

#define IAP_UART_No				0			
#define IAP_PxPU_ADR			(0x0113)		//P3PU
#define IAP_Uart_PinSelect		P3FC1_P7=1; P3FC1_P6=1; P3FC2_P7=0; P3FC2_P6=0;	PCSELR0_UART0=1; FSELR3=(FSELR0&0x0F)|(1<<4); 					
#endif

// -- UART1 Tx: P26 Rx: P25   -->
#ifdef		IAP_CONFIG_UART1_TxP26_RxP25		
#define IAP_UART_CR_ADR         (0x0102)		//P2OE
#define IAP_UART_TX_PIN         (0x06)
#define IAP_UART_RX_PIN			(0x05)
#define IAP_UART_FC_ADR         (0x0142)		//P2FC1
#define IAP_UART_FC2_ADR        (0x0152)		//P2FC2

#define IAP_UART_TDBUF_ADR      (0x00AB)       // UART1 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00AA)       // UART1 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A9)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x00A8)
#define IAP_UART_CR1_ADR        (0x00A6)
#define IAP_UART_CR2_ADR        (0x00A7)

#define IAP_UART_No				1				
#define IAP_PxPU_ADR			(0x0112)		//P2PU
#define IAP_Uart_PinSelect		P2FC1_P6=1; P2FC1_P5=1; P2FC2_P6=0; P2FC2_P5=0;	PCSELR0_UART1=0; FSELR2=(FSELR2&0x0F)|(0<<4); 						
#endif

// -- UART1 Tx: P25 Rx: P26   -->
#ifdef		IAP_CONFIG_UART1_TxP25_RxP26		
#define IAP_UART_CR_ADR         (0x0102)		//P2OE
#define IAP_UART_TX_PIN         (0x05)
#define IAP_UART_RX_PIN			(0x06)
#define IAP_UART_FC_ADR         (0x0142)		//P2FC1
#define IAP_UART_FC2_ADR        (0x0152)		//P2FC2

#define IAP_UART_TDBUF_ADR      (0x00AB)       // UART1 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00AA)       // UART1 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A9)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x00A8)
#define IAP_UART_CR1_ADR        (0x00A6)
#define IAP_UART_CR2_ADR        (0x00A7)

#define IAP_UART_No				1				
#define IAP_PxPU_ADR			(0x0112)		//P2PU
#define IAP_Uart_PinSelect		P2FC1_P6=1; P2FC1_P5=1; P2FC2_P6=0; P2FC2_P5=0;	PCSELR0_UART1=0; FSELR2=(FSELR2&0x0F)|(1<<4); 						
#endif

// -- UART1 Tx: P52 Rx: P51   -->
#ifdef		IAP_CONFIG_UART1_TxP52_RxP51		
#define IAP_UART_CR_ADR         (0x0105)		//P5OE
#define IAP_UART_TX_PIN         (0x02)
#define IAP_UART_RX_PIN			(0x01)
#define IAP_UART_FC_ADR         (0x0145)		//P5FC1
#define IAP_UART_FC2_ADR        (0x0155)		//P5FC2

#define IAP_UART_TDBUF_ADR      (0x00AB)       // UART1 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00AA)       // UART1 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A9)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x00A8)
#define IAP_UART_CR1_ADR        (0x00A6)
#define IAP_UART_CR2_ADR        (0x00A7)

#define IAP_UART_No				1				
#define IAP_PxPU_ADR			(0x0115)		//P5PU
#define IAP_Uart_PinSelect		P5FC1_P2=1; P5FC1_P1=1; P5FC2_P2=0; P5FC2_P1=0; PCSELR0_UART1=1; FSELR5=(FSELR5&0xF0)|(0<<0);  						
#endif

// -- UART1 Tx: P51 Rx: P52   -->
#ifdef		IAP_CONFIG_UART1_TxP51_RxP52		
#define IAP_UART_CR_ADR         (0x0105)		//P5OE
#define IAP_UART_TX_PIN         (0x01)
#define IAP_UART_RX_PIN			(0x02)
#define IAP_UART_FC_ADR         (0x0145)		//P5FC1
#define IAP_UART_FC2_ADR        (0x0155)		//P5FC2

#define IAP_UART_TDBUF_ADR      (0x00AB)       // UART1 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00AA)       // UART1 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00A9)       // UART1 Status register address
#define IAP_UART_DR_ADR         (0x00A8)
#define IAP_UART_CR1_ADR        (0x00A6)
#define IAP_UART_CR2_ADR        (0x00A7)

#define IAP_UART_No				1				
#define IAP_PxPU_ADR			(0x0115)		//P5PU
#define IAP_Uart_PinSelect		P5FC1_P2=1; P5FC1_P1=1; P5FC2_P2=0; P5FC2_P1=0;	PCSELR0_UART1=1; FSELR5=(FSELR5&0xF0)|(1<<0); 						
#endif

// -- UART2 Tx: P05 Rx: P04   -->
#ifdef		IAP_CONFIG_UART2_TxP05_RxP04		
#define IAP_UART_CR_ADR         (0x0100)		//P0OE
#define IAP_UART_TX_PIN         (0x05)
#define IAP_UART_RX_PIN			(0x04)
#define IAP_UART_FC_ADR         (0x0140)		//P0FC1
#define IAP_UART_FC2_ADR        (0x0150)		//P0FC2

#define IAP_UART_TDBUF_ADR      (0x00B1)       // UART2 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00B0)       // UART2 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00AF)       // UART2 Status register address
#define IAP_UART_DR_ADR         (0x00AE)
#define IAP_UART_CR1_ADR        (0x00AC)
#define IAP_UART_CR2_ADR        (0x00AD)

#define IAP_UART_No				2			
#define IAP_PxPU_ADR			(0x0110)		//P0PU
#define IAP_Uart_PinSelect		P0FC1_P5=1; P0FC1_P4=1; P0FC2_P5=0; P0FC2_P4=0;	PCSELR0_UART2=0;FSELR0=(FSELR0&0x0F)|(0<<4); 					
#endif

// -- UART2 Tx: P04 Rx: P05   -->
#ifdef		IAP_CONFIG_UART2_TxP04_RxP05		
#define IAP_UART_CR_ADR         (0x0100)		//P0OE
#define IAP_UART_TX_PIN         (0x04)
#define IAP_UART_RX_PIN			(0x05)
#define IAP_UART_FC_ADR         (0x0140)		//P0FC1
#define IAP_UART_FC2_ADR        (0x0150)		//P0FC2

#define IAP_UART_TDBUF_ADR      (0x00B1)       // UART2 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00B0)       // UART2 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00AF)       // UART2 Status register address
#define IAP_UART_DR_ADR         (0x00AE)
#define IAP_UART_CR1_ADR        (0x00AC)
#define IAP_UART_CR2_ADR        (0x00AD)

#define IAP_UART_No				2			
#define IAP_PxPU_ADR			(0x0110)		//P0PU
#define IAP_Uart_PinSelect		P0FC1_P5=1;  P0FC1_P4=1; P0FC2_P5=0; P0FC2_P4=0; PCSELR0_UART2=0; FSELR0=(FSELR0&0x0F)|(1<<4); 					
#endif

// -- UART2 Tx: P31 Rx: P30   -->
#ifdef		IAP_CONFIG_UART2_TxP31_RxP30		
#define IAP_UART_CR_ADR         (0x0103)		//P3OE
#define IAP_UART_TX_PIN         (0x01)
#define IAP_UART_RX_PIN			(0x00)
#define IAP_UART_FC_ADR         (0x0143)		//P3FC1
#define IAP_UART_FC2_ADR        (0x0153)		//P3FC2

#define IAP_UART_TDBUF_ADR      (0x00B1)       // UART2 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00B0)       // UART2 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00AF)       // UART2 Status register address
#define IAP_UART_DR_ADR         (0x00AE)
#define IAP_UART_CR1_ADR        (0x00AC)
#define IAP_UART_CR2_ADR        (0x00AD)

#define IAP_UART_No				2			
#define IAP_PxPU_ADR			(0x0113)		//P3PU
#define IAP_Uart_PinSelect		P3FC1_P1=1;  P3FC1_P0=1; P3FC2_P1=0; P3FC2_P0=0; PCSELR0_UART2=1; FSELR3=(FSELR3&0xF0)|(0<<0); 					
#endif

// -- UART2 Tx: P30 Rx: P31   -->
#ifdef		IAP_CONFIG_UART2_TxP30_RxP31		
#define IAP_UART_CR_ADR         (0x0103)		//P3OE
#define IAP_UART_TX_PIN         (0x00)
#define IAP_UART_RX_PIN			(0x01)
#define IAP_UART_FC_ADR         (0x0143)		//P3FC1
#define IAP_UART_FC2_ADR        (0x0153)		//P3FC2

#define IAP_UART_TDBUF_ADR      (0x00B1)       // UART2 Tx buffer register address
#define IAP_UART_RDBUF_ADR      (0x00B0)       // UART2 Rx buffer register address
#define IAP_UART_SR_ADR         (0x00AF)       // UART2 Status register address
#define IAP_UART_DR_ADR         (0x00AE)
#define IAP_UART_CR1_ADR        (0x00AC)
#define IAP_UART_CR2_ADR        (0x00AD)

#define IAP_UART_No				2			
#define IAP_PxPU_ADR			(0x0113)		//P3PU
#define IAP_Uart_PinSelect		P3FC1_P1=1;  P3FC1_P0=1; P3FC2_P1=0; P3FC2_P0=0; PCSELR0_UART2=1; FSELR3=(FSELR3&0xF0)|(1<<0); 					
#endif

/* =======================End of UART Configure ================================*/ 
/* =============================================================================*/






// IAP Boot related data structure
typedef struct
{
	// Memory address related
	unsigned int    norBootAddr;
	
	// Boot pin related
	volatile unsigned char	 *ptrBootPinFC;    // pointer to Boot GPIO Pin Function register
	volatile unsigned char	 *ptrBootPinPU;    // pointer to Boot GPIO Pin Pull-Up register
	volatile unsigned char	 *ptrBootPinPD;    // pointer to Boot GPIO Pin Pull-Down register
	volatile unsigned char	 *ptrBootPinCR;    // pointer to Boot GPIO Pin Control register
	volatile unsigned char	 *ptrBootPinPRD;   // pointer to Boot GPIO Pin PRD register
	volatile unsigned char	 valBootDefaultHL; // pointer to Boot GPIO Default High/Low
	volatile unsigned char	 valBootEnableHL;  // pointer to Boot GPIO Enable High/Low
	unsigned char              valBootPinBit;       // Ex 0x02 is Px2
	
	// UART releted
	volatile unsigned char    *ptrUartPinCR;
	volatile unsigned char    *ptrUartPinFC;
	volatile unsigned char    valUartTxPin;
	volatile unsigned char    valUartRxPin;

	volatile unsigned char	 *ptrUartTxBuf;     // Pointer to UART Tx device buffer (ex. 0x001) 
	volatile unsigned char	 *ptrUartRxBuf;     // Pointer to UART Tx device buffer (ex. 0x001) 
	volatile unsigned char	 *ptrUartSR;        // UART status byte(bit0: TBFL 0:buffer empty,  1:buffer full) 
	volatile unsigned char    *ptrUartDR;
	volatile unsigned char    *ptrUartCR1;
	volatile unsigned char    *ptrUartCR2;
	
	volatile unsigned char    *ptrPxPU;		//modified by Billy
	
}IAP_Define;


extern IAP_Define IAP_Dev_define;   // define IAP related registers & runtime variable


// ============================================================ //
#endif
// ============================================================ //
 

